# Copyright (c) 2000-2011, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%bcond_with mead

%if "%{?rhel}" == "6"
%define _jarsign_opts --unsign=%{_javadir}
%endif

%if %without mead
%bcond_with javadoc
%bcond_with repolib
%else
%bcond_with javadoc
%bcond_without repolib
%endif

%define repodir %{_javadir}/repository.jboss.com/org/jboss/netty/%{namedversion}-brew
%define repodirlib %{repodir}/lib
%define repodirsrc %{repodir}/src

%define reltag .Final
%global namedversion %{version}%{?reltag}

Name:           netty
Version:        3.2.4
Release:        1%{?dist}
Epoch:          0
Summary:        Asynchronous event-driven network application framework and tools
License:        ASL 2.0
Group:          Development/Java
URL:            http://www.jboss.org/netty/
# svn export http://anonsvn.jboss.org/repos/netty/tags/netty-3.2.3.Final && tar cjf netty-3.2.3.Final.tar.bz2 netty-3.2.3.Final
# Exported revision 2389.

# git clone https://github.com/netty/netty.git && cd netty && git archive --prefix="netty-3.2.4.Final/" --format=tar netty-3.2.4.Final | bzip2 > ../netty-3.2.4.Final.tar.bz2
%if %without mead
Source0:        netty-3.2.4.Final.tar.bz2
%endif
Source1:        netty-component-info.xml
# Do not use buildnumber during brew build as it tries to check and update src
# Do not package as bundle as we are not building javadoc since it R: apiviz
Patch0:         netty-pom.patch
%if %with mead
BuildRequires:  %{name}-mead = %{namedversion}
%else
BuildRequires:  ant >= 0:1.7.1
BuildRequires:  ant-contrib >= 0:1.0-0.b3
BuildRequires:  apiviz >= 0:1.3.0
BuildRequires:  dtdparser
BuildRequires:  easymock-classextension2
BuildRequires:  felix-osgi-core >= 0:1.4.0
BuildRequires:  felix-osgi-compendium >= 0:1.4.0
BuildRequires:  google-guice
BuildRequires:  google-parent
BuildRequires:  apache-ivy
BuildRequires:  jboss-common-logging-spi
BuildRequires:  jboss-microcontainer2 >= 0:2.0.6
BuildRequires:  jboss-parent
BuildRequires:  jboss-xnio-base
BuildRequires:  log4j >= 0:1.2.14
BuildRequires:  protobuf-java >= 0:2.3.0
BuildRequires:  spring2-beans
BuildRequires:  xerces-j2 >= 0:2.9.1
BuildRequires:  xml-commons-jaxp-1.3-apis >= 0:1.3.04
BuildRequires:  maven2 >= 0:2.0.7-8
BuildRequires:  maven-buildmagic-thirdparty-plugin
BuildRequires:  maven2-plugin-antrun
BuildRequires:	maven2-plugin-assembly
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-deploy
BuildRequires:  maven2-plugin-eclipse
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
%if %with javadoc
BuildRequires:  maven2-plugin-javadoc
%endif
BuildRequires:  maven2-plugin-release
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven2-plugin-source
BuildRequires:  maven-doxia-sitetools
BuildRequires:  maven-surefire-maven-plugin
BuildRequires:  maven-surefire-provider-junit4
BuildRequires:  maven-shared-reporting-impl
BuildRequires:  maven-plugin-bundle
BuildRequires:  maven-jdocbook-plugin
%if 0
BuildRequires:  buildnumber-maven-plugin
%endif
%endif
#
BuildRequires:  java-javadoc
%if 0
# FIXME: For soem reason, this subpackage doesn't get uploaded
BuildRequires:  protobuf-java-javadoc
%endif
%if 0
# FIXME: We don't have a virtual for api javadocs
BuildRequires:  servlet-api-javadoc
%endif
BuildRequires:  felix-osgi-core-javadoc
BuildRequires:  slf4j-javadoc
BuildRequires:  commons-logging-javadoc
BuildRequires:  log4j-javadoc
#
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root
	
%description
The Netty project is an effort to provide an asynchronous event-driven
network application framework and tools for rapid development of
maintainable high performance and high scalability protocol servers and
clients.  In other words, Netty is a NIO client server framework which
enables quick and easy development of network applications such as protocol
servers and clients. It greatly simplifies and streamlines network
programming such as TCP and UDP socket server.

%if %with javadoc
%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
%{summary}.
%endif

%if %with repolib
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java

%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%prep
%if %without mead
%setup -q -n %{name}-%{namedversion}
%patch0 -p0 -b .sav0
%endif

%build
%if %without mead
export MAVEN_REPO_LOCAL=`pwd`/.m2/repository
export ALT_DEPLOYMENT_REPOSITORY=oss-releases::default::file:`pwd`/maven2-brew
export MAVEN_OPTS="-Xms1g -Xmx1g"
# XXX: tests require network (hang)
%{_bindir}/mvn-jpp -e -Dmaven.repo.local=${MAVEN_REPO_LOCAL} -DaltDeploymentRepository=${ALT_DEPLOYMENT_REPOSITORY} -Dmaven.test.skip deploy \
%if %with javadoc
javadoc:aggregate
%else
%endif
%endif

%install
%{__rm} -rf %{buildroot}

%{__mkdir_p} %{buildroot}%{_javadir}/%{name}
%if %without mead
pushd maven2-brew
%{__cp} -p org/jboss/netty/netty/%{namedversion}/netty-%{namedversion}-sources.jar %{buildroot}%{_javadir}/%{name}-%{namedversion}-sources.jar
%{__cp} -p org/jboss/netty/netty/%{namedversion}/netty-%{namedversion}.jar %{buildroot}%{_javadir}/%{name}-%{namedversion}.jar
popd
%else
XXX
%{__cp} -p %{_javadir}/jbossas-fordev/netty-%{namedversion}.jar %{buildroot}%{_javadir}/%{name}-%{namedversion}.jar
%{__cp} -p %{_javadir}/jbossas-fordev/netty-%{namedversion}-sources.jar %{buildroot}%{_javadir}/%{name}-%{namedversion}-sources.jar
%{__unzip} -j %{_javadir}/jbossas-fordev/org.jboss.netty-netty-%{namedversion}-sources.zip netty-%{namedversion}/COPYRIGHT.txt netty-%{namedversion}/NOTICE.txt netty-%{namedversion}/LICENSE.txt 
%endif
(cd %{buildroot}%{_javadir} && for jar in *-%{namedversion}*; do %{__ln_s} ${jar} `/bin/echo ${jar} | %{__sed} -e "s|-%{namedversion}||g"`; done)

# poms
%{__mkdir_p} %{buildroot}%{_datadir}/maven2/poms
%if %without mead
pushd maven2-brew
%{__cp} -p org/jboss/netty/netty/%{namedversion}/netty-%{namedversion}.pom %{buildroot}%{_datadir}/maven2/poms/JPP-%{name}.pom
popd
%else
%{__cp} -p %{_javadir}/jbossas-fordev/netty-%{namedversion}.pom %{buildroot}%{_datadir}/maven2/poms/JPP-%{name}.pom
%endif

# depmaps
%add_to_maven_depmap org.jboss.netty netty %{namedversion} JPP %{name}

%{__mkdir_p} %{buildroot}%{_docdir}/%{name}-%{namedversion}
%{__cp} -p *.txt %{buildroot}%{_docdir}/%{name}-%{namedversion}

# javadoc
%if %with javadoc
%{__mkdir_p} %{buildroot}%{_javadocdir}/%{name}-%{namedversion}
%{__cp} -pr target/site/apidocs/* %{buildroot}%{_javadocdir}/%{name}-%{namedversion}
ln -s %{name}-%{namedversion} %{buildroot}%{_javadocdir}/%{name}
%endif

# repolib
%if %with repolib
%{__mkdir_p} %{buildroot}%{repodir}
%{__mkdir_p} %{buildroot}%{repodirlib}
%{__cp} -p %{SOURCE1} %{buildroot}%{repodir}/component-info.xml
tag=`/bin/echo %{version}-brew`
%{__sed} -i "s/@VERSION@/$tag/g" %{buildroot}%{repodir}/component-info.xml
tag=`/bin/echo %{name}-%{version}-%{release} | %{__sed} 's|\.|_|g'`
%{__sed} -i "s/@TAG@/$tag/g" %{buildroot}%{repodir}/component-info.xml
%if %without mead
%{__mkdir_p} %{buildroot}%{repodirsrc}
%{__cp} -p %{SOURCE0} %{buildroot}%{repodirsrc}
%{__cp} -p %{PATCH0} %{buildroot}%{repodirsrc}
%{__cp} -p %{buildroot}%{_datadir}/maven2/poms/JPP-%{name}.pom %{buildroot}%{repodirlib}/netty.pom
%else
%{__cp} -p %{_javadir}/jbossas-fordev/org.jboss.netty-netty-%{namedversion}-sources.zip %{buildroot}%{repodirsrc}
%{__cp} -p %{_javadir}/jbossas-fordev/netty-%{namedversion}.pom %{buildroot}%{repodirlib}/netty.pom
%endif
%{__cp} -p %{buildroot}%{_javadir}/%{name}.jar %{buildroot}%{repodirlib}/netty.jar
%{__cp} -p %{buildroot}%{_javadir}/%{name}-sources.jar %{buildroot}%{repodirlib}/netty-sources.jar
%if %without mead
%{__mkdir_p} %{buildroot}%{_javadir}/repository.jboss.com
%{__cp} -pr maven2-brew %{buildroot}%{_javadir}/repository.jboss.com
%endif
%endif

%clean
%{__rm} -rf %{buildroot}

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%doc %dir %{_docdir}/%{name}-%{namedversion}
%doc %{_docdir}/%{name}-%{namedversion}/COPYRIGHT.txt
%doc %{_docdir}/%{name}-%{namedversion}/LICENSE.txt
%doc %{_docdir}/%{name}-%{namedversion}/NOTICE.txt
%{_javadir}*/%{name}-%{namedversion}-sources.jar
%{_javadir}*/%{name}-sources.jar
%{_javadir}*/%{name}-%{namedversion}.jar
%{_javadir}*/%{name}.jar
%{_datadir}/maven2/poms/JPP-%{name}.pom
%{_mavendepmapfragdir}/%{name}

%if %with javadoc
%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{namedversion}
%{_javadocdir}/%{name}
%endif

%if %with repolib
%files repolib
%defattr(0644,root,root,0755)
%dir %{_javadir}*
%if %with javadoc
%exclude %dir %{_javadocdir}
%endif
%{_javadir}*/repository.jboss.com
%endif

%changelog
* Tue Jul 12 2011 David Walluck <dwalluck@redhat.com> 0:3.2.4-1
- 3.2.4.Final
- use proper version in file and dir names
- fix RPM build
- fix repolib

* Tue Apr 05 2011 Martha Benitez <mbenitez@redhat.com> - 0:3.2.3-5.3
- Update repolib condition in #repolib section
 
* Tue Feb 08 2011 Fernando Nasser <fnasser@redhat.com> 0:3.2.3-5.2
- Unsign JARs in javadir as they came signed from MEAD

* Wed Jan 26 2011 Fernando Nasser <fnasser@redhat.com> - 0:3.2.3-5
- Do not reupload artifacts to mead as they are now already signed

* Fri Dec 17 2010 Fernando Nasser <fnasser@redhat.com> - 0:3.2.3-4
- Use MEAD binaries

* Fri Dec 17 2010 Fernando Nasser <fnasser@redhat.com> - 0:3.2.3-3.11
- Update to 3.2.3.Final

* Fri Nov 19 2010 Permaine Cheung <pcheung@redhat.com> - 0:3.2.1-1.Final.1
- Add upload.sh and content of maven2-brew to repolib
- Fix %%files for signed jars

* Fri Aug 06 2010 Permaine Cheung <pcheung@redhat.com> - 0:3.2.1-1.Final
- Update to 3.2.1.Final

* Wed Jun 02 2010 Permaine Cheung <pcheung@redhat.com> - 0:3.2.0-3.Final
- Update to 3.2.0.Final
- Rediff pom patch

* Mon May 17 2010 Permaine Cheung <pcheung@redhat.com> - 0:3.2.0-2.CR1
- Update to CR1
- Rediff pom

* Tue Apr 27 2010 Permaine Cheung <pcheung@redhat.com> - 0:3.2.0-1.BETA1
- First release
